package com.qmth.themis.task.quartz;

import com.qmth.themis.business.service.TEExamSummaryService;
import com.qmth.themis.business.service.ThemisCacheService;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.quartz.QuartzJobBean;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.Map;
import java.util.Set;

/**
 * @Description: 考试统计
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2023/10/27
 */
@Component
public class ExamSummaryJob extends QuartzJobBean {
    private final static Logger log = LoggerFactory.getLogger(ExamSummaryJob.class);

    @Resource
    ThemisCacheService themisCacheService;

    @Resource
    TEExamSummaryService teExamSummaryService;

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        log.info("ExamSummaryJob进来了,context:{}", context);
        Set<Long> examIdSet = themisCacheService.getTodayExamListCache();
        if (!CollectionUtils.isEmpty(examIdSet)) {
            for (Long l : examIdSet) {
                Map<String, Set<String>> map = themisCacheService.getTodayExamCache(l.toString());
                map.forEach((k, v) -> {
                    teExamSummaryService.examSummary(l, Long.parseLong(k), v);
                });
            }
        }
    }
}
